routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/online-shop', function (){
    return view('Template/Home');
});


Route::group(['prefix'=>'/online-shop'], function(){

    Route::resource('/User','UserController');
    Route::resource('/Book','BookController');
    Route::resource('/Category','CategoryController');
    Route::resource('/StatusOrder','OrderController');

    Route::get('/User/search/email','UserController@search')->name('User.search');
    Route::get('/StatusOrder/search/invoice_number','OrderController@search')->name('StatusOrder.search');
    Route::get('/Book/search/title','BookController@search')->name('Book.search');
    Route::get('/Category/search/category_name','CategoryController@search')->name('Category.search');
});

app/Books.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Books extends Model
{
    protected $primarykey = 'id';

    protected $fillable = [
        'title',
        'description',
        'author',
        'publisher',
        'cover',
        'price',
        'stock'
    ];

    public function category(){
        return $this->belongsToMany('App\Category');
    }
}

app/Http/Controllers/BookController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Books;
use App\Category;
use App\Book_Category;

class BookController extends Controller
{

    public function index()
    {

        $Book  =   Books::paginate(5);
        return view('Book.index', ['Book'=>$Book]);
    }

    public function create()
    {

        $categories     =   Category::all();
        return view('Book.create', ['categories'=>$categories]);
    }

    
    public function store(Request $request)
    {

       $request->validate([
            'title'         =>  'required|max:191',
            'author'        =>  'required|string|max:191',
            'publisher'     =>  'required|max:191',
            'price'         => 'required|numeric',
            'stock'         => 'required|numeric',
            'description'   => 'required|max:191',
            'category_name' => 'required',
            'cover'         => 'required|image',
       ]);

       if($request->hasFile('cover')){
           $gambar          =   $request->file('cover');
           $namepicture     =   '/Picture/Book/'.time().'.'.$gambar->getClientOriginalExtension();
           $directory       =   public_path('/Picture/Book');
           $gambar->move($directory, $namepicture);
       }

       Books::create([
            'title'         =>      $request->title,
            'author'        =>      $request->author,
            'publisher'     =>      $request->publisher,
            'price'         =>      $request->price,
            'stock'         =>      $request->stock,
            'description'   =>      $request->description,
            'cover'         =>      $namepicture,
       ]);

       $Book   =   Books::latest()->first();

    //    foreach($request->category_name as $genre){
    //        Book_Category::create([
    //             'book_id'       =>  $Book->id,
    //             'category_id'   =>  $genre
    //        ]);
    //    }
       return redirect ('/online-shop/Book');
    }

    
    public function show($id)
    {
        $Book  =   Books::find($id);
        return view('Book.show', ['Book'=>$Book]);   
    }

    public function edit($id)
    {
        $Book      =   Books::find($id);
        $categories =   Category::all();
        return view('Book.edit',    ['Book'=>$Book, 'categories'=>$categories]);
    }

    
    public function update(Request $request, $ID)
    {
        $request->validate([
            'title'         =>      'required|max:191',
            'author'        =>      'required|string|max:191',
            'publisher'     =>      'required|max:191',
            'price'         =>      'required|numeric',
            'stock'         =>      'required|numeric',
            'cover'         =>      'required|image',
            'description'   =>      'required|max:191',
            'category_name' =>      'required'
        ]);

        $Book = Book::find($id);
        $Book->title       =   $request->title;
        $Book->author      =   $request->author;
        $Book->publisher   =   $request->publisher;
        $Book->price       =   $request->price;
        $Book->stock       =   $request->stock;
        $Book->description =   $request->description;

        if($request->hasFile('cover')){
            $gambar         =   $request->file('cover');
            $namepicture    =   '/Picture/Book/'.time().','.$gambar->getClientOriginalExtension();
            $directory      =   public_path('/Picture/Book');
            $gambar->move($directory, $namepicture);
        }
        else{
            $namepicture    =   $Book->cover;
        }
        
        $Book->cover=$namepicture;
        $Book->save();

        $Book_categories = Book_Category::where('book_id', $id)->delete();

        // foreach($request->category_name as $genre){
        //     Book_Category::create([
        //         'book_id'       =>  $id,
        //         'category_id'   =>  $genre
        //     ]);
        // }
        return redirect('/online-shop/Book');
    }

    public function destroy($id)
    {
        $Book = Books::find($id);
        $Book->delete();
        return redirect ('/online-shop/Book');
    }

    public function search (Request $request){
        $searching  =   $request->$searching;

        $Book  =   Books::where('title','LIKE','%'.$searching.'%')->paginate();
        return view('Book.index',   ['Book'=>$Book]);
        }

}

    

resources/views/Book/Show.blade.php
@extends('Template.Home')
    @section('title')
        Detail Book
    @endsection

@section('content')
    <h1>Detail Book</h1>
    <hr>
    <br>
            <div class="card bg-white border-info" style="max-witdh: 70%; margin: auto; min-height: 400px;">
                <div class="row" style="padding;25px">
                    <div class="col-md-2 offset-md-5 offset-sm-4">

                        <img src="{{asset($Book['cover']) }}" style="height:150px; width:150px;" class="rounded-circle" alt="cover">
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-12 text-center">

                        <h3>{{ $Book['title'] }}</h3>
                    </div>
                </div>
                <hr>
                <br>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Author
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{ $Book['author']}}
                    </div>
                    <br>
                </div>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Publisher
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{$Book['publisher']}}
                    </div>
                    <br>
                </div>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Deskripsi
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{$Book['description']}}
                    </div>
                    <br>
                </div>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Price
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{$Book['price']}}
                    </div>
                    <br>
                </div>

                {{-- <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Genre
                    </div>
                    <div class="col-md-4 col-sm-4">
                        <ul>
                        @foreach ($Book->category as $category)
                            <li>{{ $category->category_name }}</li>
                        @endforeach
                        </ul>
                    </div>		
                </div> --}}

            </div>

resources/views/Book/create.blade.php
@extends('Template.Home')
@section('title')
    Create Book
@endsection

@section('content')
    <div class="container">
        <h3>Create Book</h3>
        <hr>
            <div class="card border-primary" style="max-width: 70%; margin: auto; margin-top: 40px;">
                <div class="card-header bg-primary text-white">
                    <h5>Create a New Book</h5>
                </div>

                <div class="card-body">
                    <div class="contrainer text-primary">
                        <form action="{{ route('Book.store') }}" class="form-group" method="POST" enctype="multipart/form-data">
                            @csrf
                                <div class="row">
                                    <div class="col-md-3">

                                        <label for="title">Book Name</label>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="title" class="form-control" id="title">
                                        {{($errors->has('title')) ? $errors->first('title') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">

                                        <label for="author">Author</label>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="author" id="author" class="form-control">
                                        {{($errors->has('author')) ? $errors->first('author') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">

                                        <label for="publisher">Publisher</label>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="publisher" id="publisher" class="form-control">
                                        {{($errors->has('publisher')) ? $errors->first('publisher') : ""}}
                                    </div>
                                </div>
                                <br>
                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="price" class="text-primary">Price</label>
                                    </div>
        
                                    <div class="col-md-8">
                                        <input type="text" name="price" id="price" class="form-control">
                                        {{($errors->has('price')) ? $errors->first('price') : ""}}
                                    </div>
                                </div>
                                <br>
                                
                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="stock" class="text-primary">Stock</label>
                                    </div>
        
                                    <div class="col-md-8">
                                        <input type="text" name="stock" id="stock" class="form-control">
                                        {{($errors->has('stock')) ? $errors->first('stock') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="description" class="text-primary">description</label>
                                    </div>
        
                                    <div class="col-md-8">
                                        <input type="text" name="description" id="description" class="form-control">
                                        {{($errors->has('description')) ? $errors->first('description') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="category_name" class="text-primary">Category Book</label>
                                    </div>
        
                                    <div class="col-md-8">
                                        <select name="category_name" id="category_name" class="form-control">
                                            @foreach ($categories as $category)
                                                <option value="{{ $category->id}}">{{ $category->category_name }}</option>
                                            @endforeach
                                        </select>
                                        {{($errors->has('category_name')) ? $errors->first('category_name') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="input-group mb-3">
                                        <div class="col-md-3 text-primary">
                                              Cover
                                        </div>
                                    <div class="col-md-8">
                                        <div class="custom-file">
                                            <label for="cover" class="custom-file-label">Select Cover</label>
                                            <input class="custom-file-input" type="file" name="cover" id="cover">
                                        </div>
                                        {{ ($errors->has('cover')) ? $errors->first('cover') : "" }}
                                    </div>
                                </div>
                            </div>
                            <br>
                                <div class="row">
                                    <div class="col-md-3 offset-md-5 offset-sm-4">
                                        <button type="submit" class="btn btn-outline-primary">Create</button>
                                    </div>
                                </div>
                        </form>
                    </div>
                </div>
            </div>
    </div>
@endsection

resources/views/Book/edit.blade.php
@extends('Template.Home')
    @section('title')
        Change Book
    @endsection

@section('content')
    <div class="container">
        <h3>Form Change Book</h3>
        <hr>

            <div class="card border-primary" style="max-width: 70%; margin:auto; margin-top:40px;">
                <div class="card-header bg-primary text-white">
                    <h5>{{ $Book['title'] }}</h5>
                </div>

                <div class="card-body">
                    <div class="container text-primary">

                        <form action="{{ route('Book.update',$Book['id']) }}" method="POST" class="form-group"
                        enctype="multipart/form-data">

                        @csrf
                        @method('PUT')
                            <div class="row">
                            <div class="col-md-3">

                                <label for="title" class="text-primary">BookName</label>
                            </div>

                            <div class="col-md-8">
                                <input type="text" name="title" id="title" value="{{ $Book->title }}">
                                {{($errors->has('title')) ? $errors->first('title') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="author" class="text-primary">Author</label>
                            </div>
                            <div class="col-md-8">
                                <input type="text" class="form-control" name="author" id="author" value="{{ $Book->author }}">
                                {{($errors->has('author')) ? $errors->first('author') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="publisher" class="text-primary">Publisher</label>
                            </div>
                            <div class="col-md-8">
                                <input type="text" name="publisher" id="publisher" class="form-control" value="{{ $Book->publisher }}">
                                {{($errors->has('publisher')) ? $errors->first('publisher') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="price" class="text-primary">Price</label>
                            </div>
                            <div class="col-md-8">
                                <input type="text" name="price" id="price" class="form-control" value="{{ $Book->price }}">
                                {{($errors->has('price')) ? $errors->first('price') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="stock" class="text-primary">Stock</label>
                            </div>
                            <div class="col-md-8">
                                <input type="text" name="stock" id="stock" class="form-control" value="{{ $Book->stock }}">
                                {{($errors->has('stock')) ? $errors->first('stock') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="cover" class="text-primary">Cover</label>
                            </div>
                            <div class="col-md-8">
                                <img src="{{asset($Book->cover) }}" class="img-thumbnail"
                                alt="gambar" height="150px" width="150px">
                                <div class="custom-file">
                                     <label for="CustomFile" class="custom-file-label">File Cover</label>
                                         <input type="file" name="cover" id="CustomFile" class="custom-file-input">
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="description" class="text-primary">Description</label>
                            </div>
                            <div class="col-md-8">
                                <input type="textarea" name="description" id="description" class="form-control" value="{{ $Book->description }}">
                                {{($errors->has('description')) ? $errors->first('description') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="category_name" class="text-primary">Genre</label>
                            </div>
                            <div class="col-md-8">
                                <select name="category_name" id="category_name" class="form-control">
                                    @foreach($categories as $category)
                                    <option value="{{ $category->id}}">{{ $category->category_name}}</option>
                                    @endforeach
                                </select>
                                {{($errors->has('category_name')) ? $errors->first('category_name') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3 offset-md-5 offset-md-5">
                                <button type="submit" class="btn btn-outline-primary">Update</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
         </div>
    </div>
@endsection

resources/views/Book/index.blade.php
@extends('Template.Home')
            @section('title')
                List Book
            @endsection
        @section('css')
        <style>
            body{
                padding-top: 30px;
            }

            th, td{
                padding: 10px;
                text-align: center;
            }

            td a{
                margin: 3px;
                align-content: center;
                color: white;
            }

            td a:hover{
                text-decoration: none;
            }

            td button{
                margin-top: 5px;
                cursor: pointer;
            }
        </style>
        @endsection
        @section('content')
            <div class="container">
                <h3> List Book </h3><hr>
                    <div class="row">
                        <div class="col-md-2">
                            <a class="btn btn-outline-primary" href=" {{ route('Book.create')}} ">
                                <span data-feather="plus-circle"></span>
                                New<span class="sr-only">(current)</span>
                            </a>
                        </div>

                        <div class="col-md-8">
                            <form action="{{ route('Book.search')}}" class="form-inline" method="GET">
                                <div class="form-group mx-sm-3 mb-2">
                                    <input class="form-control" name="searching" id="searching" placeholder="Search Book .." value="{{old('searching')}}">
                                </div>
                                <button class="btn btn-primary mb-2" type="submit">Search</button>
                            </form>
                        </div>
                    </div>
                    <br>
                    <div class="table-responsive">
                        <table class="table table=striped">
                            <thead>
                                <tr class="table-primary">
                                    <th scope="col">ID</th>
                                    <th scope="col">Title</th>
                                    <th scope="col">Publisher</th>
                                    <th scope="col">Price</th>
                                    <th scope="col">Cover</th>
                                    <th scope="col">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($Book as $Books)
                                    <tr>
                                        <td>{{ $Books['id'] }}</td>
                                        <td>{{ $Books['title'] }}</td>
                                        <td>{{ $Books['publisher'] }}</td>
                                        <td>{{ $Books['price'] }}</td>

                                        <td>
                                            <img src="{{ asset($Books['cover']) }}" alt="cover" width="80px">
                                        </td>
                                        <td>
                                        <a class="btn-sm btn-primary" href="{{ route('Book.show', $Books['id']) }}">
                                            <span data-feather="eye"></span>
                                            Detail <span class="sr-only">(current)</span>
                                        </a>
                                        <a class="btn-sm btn-success d-inline" href="{{route('Book.edit',$Books['id']) }}">
                                            <span data-feather="edit-2"></span>
                                            Edit <span class="sr-only">(current)</span>
                                        </a>
                                        <form class="d-inline" onsubmit="return confirm('Delete This User Permanently ?')"
                                        action="{{route ('Book.destroy', $Books['id']) }}" method="POST">
                                            @csrf
                                                @method('DELETE')
                                                    <button type="submit" class="btn-sm btn-danger" value="Delete">
                                                        <span data-feather="trash"></span>
                                                        Delete
                                                        <span class="sr-only">(current)</span>
                                                    </button>
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                    {{$Book->links()}}
                </div>
            </div>
        @endsection